=== src/mesh/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# This is needed to export the symbols in this shared library.
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMAKING_MODULE_MESH")

ADD_LIBRARY(Mesh
	tri/TriMesh.cpp
)

TARGET_LINK_LIBRARIES(Mesh Base)

# Link the target against the Qt libraries. 
TARGET_LINK_LIBRARIES(Mesh ${QT_LIBRARIES})

# This library will be part of the installation package.
IF(NOT OVITO_MONOLITHIC_BUILD)
	INSTALL(TARGETS Mesh DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}")
ENDIF(NOT OVITO_MONOLITHIC_BUILD)
