=== src/povray/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# The header files that need to be processed by the QT meta-object compiler.
SET(POVRay_MOC_HDRS
	export/POVRayExporter.h
	export/POVRayExportInterface.h
	export/MeshExportInterface.h	
	
	renderer/POVRayRenderer.h
	renderer/POVRayRendererEditor.h
)

# The regular source files of this library.
SET(POVRay_SRCS
	export/POVRayExporter.cpp
	export/MeshExportInterface.cpp	
	
	renderer/POVRayRenderer.cpp
	renderer/POVRayRendererEditor.cpp
)

# Add optional source files needed for scripting of the plugin.
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	LIST(APPEND POVRay_SRCS python/PythonInterface.cpp)
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

# Use the QT meta-object compiler to generate additional code.
QT4_WRAP_CPP(POVRay_MOC_SRCS ${POVRay_MOC_HDRS} OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED)

# Generate plugin module.
OVITO_PLUGIN(POVRay
	SOURCES PrecompiledHeader.cpp ${POVRay_SRCS} ${POVRay_MOC_SRCS}
	LIB_DEPENDENCIES Mesh
	OPTIONAL_PLUGIN_DEPENDENCIES Scripting
	PCH "${CMAKE_SOURCE_DIR}/src/core/Core.h"
)
