=== src/stdobjects/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# The header files that need to be processed by the QT meta-object compiler.
SET(StdObjects_MOC_HDRS
	geometry/box/BoxObject.h
	geometry/box/BoxCreationMode.h
	geometry/cylinder/CylinderObject.h
	geometry/cylinder/CylinderCreationMode.h
	shapes/rectangle/RectangleObject.h
	shapes/rectangle/RectangleCreationMode.h
	shapes/circle/CircleObject.h
	shapes/circle/CircleCreationMode.h
	cameras/CameraObject.h
	cameras/FreeCameraCreationMode.h
	cameras/TargetCameraCreationMode.h	
	helpers/TargetObject.h
)

# The regular source files of this library.
SET(StdObject_SRCS
	geometry/box/BoxObject.cpp
	geometry/cylinder/CylinderObject.cpp
	shapes/rectangle/RectangleObject.cpp
	shapes/circle/CircleObject.cpp
	cameras/CameraObject.cpp
	helpers/TargetObject.cpp	
)

# Use the QT meta-object compiler to generate additional code.
QT4_WRAP_CPP(StdObjects_MOC_SRCS ${StdObjects_MOC_HDRS} OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED)

# Generate plugin module.
OVITO_PLUGIN(StdObjects
	SOURCES PrecompiledHeader.cpp ${StdObject_SRCS} ${StdObjects_MOC_SRCS}
	LIB_DEPENDENCIES Mesh
	PCH "${CMAKE_SOURCE_DIR}/src/core/Core.h"
)
