=== debian/changelog ===
ovito (0.9.5-4) unstable; urgency=medium

  * [10caab6] Remove dirs-directory.
  * [9967551] Reformat debian/copyright in DEP-5.
  * [0f18544] Set Standards-Version: 3.9.5
  * [3584ded] Simlpify debian/rules.
  * [b073cae] Set Debian-Science-Team as maintainer of the package. 
              (Closes: #674283)
  * [872d024] Use wrap-and-sort.

 -- Anton Gladky <gladk@debian.org>  Sun, 02 Mar 2014 22:22:27 +0100

ovito (0.9.5-3) unstable; urgency=low

  * QA upload.
  * Add debian/patches/rcc_config_fix.diff (Closes: #730890)
    - Cherrypick of upstream git version of cmake/CompileQtResource.cmake to
      fix FTBFS with current Qt4

 -- Scott Kitterman <scott@kitterman.com>  Wed, 19 Feb 2014 09:53:47 -0500

ovito (0.9.5-2) unstable; urgency=low

  * QA upload.
  * Use libtachyon-dev instead of the embedded copy of this library shipped 
    with the package:
    - debian/control: add libtachyon-dev as a build dependency.
    - 50-use-libtachyon.patch: Use libtachyon-dev instead of embedded 
      tachyonlib.
    - ovito.lintian-overrides: override lintian error because libTachyon.so
      is a plugin.
  * Update compatibility level to 9.  

 -- Mònica Ramírez Arceda <monica@debian.org>  Mon, 28 May 2012 00:45:56 +0200

ovito (0.9.5-1) unstable; urgency=low

  * QA upload.
  * New upstream release. (Closes: #672047)
  * Set Maintainer field to Debian QA Group.
  * Add python dependency.
  * Bump to Standards-Version 3.9.3. No changes required.
  * Remove debian/patches/boost1.48: fixed in upstream.
  * Remove autogenerated patches: debian-changes-0.9.2-1~2 and 
    debian-changes-0.9.2-1~3. Organize these changes in four patches:
    * 10-repository-revision.patch
    * 20-desktop-entry-encoding.patch
    * 30-fix-typos.patch
    * 40-use-libmuparser.patch 

 -- Mònica Ramírez Arceda <monica@debian.org>  Thu, 24 May 2012 23:44:09 +0200

ovito (0.9.2-1.2) unstable; urgency=low

  * Non-Maintainer Upload.
  * Fix FTBFS (Closes: #651331)
    - debian-changes-0.9.2-1~2: updated patch to include to muParser.h
    - debian-changes-0.9.2-1~3: new patch to use muparser built in
      atan2 function
    - debian/control: BD on libmuparser-dev (>= 2.1.0)

 -- Scott Howard <showard@debian.org>  Tue, 27 Mar 2012 21:31:13 -0400

ovito (0.9.2-1.1) unstable; urgency=low

  * Non-Maintainer Upload.
  
  * patches/boost1.48: New.  Work around moc limitation.  Closes: #652795.

 -- Steve M. Robbins <smr@debian.org>  Sun, 22 Jan 2012 20:11:46 -0600
