=== debian/control ===
Source: ovito
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Anton Gladky <gladk@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 9),
 docbook-xml,
 docbook-xsl,
 docbook-xsl-doc-html,
 libboost-dev,
 libboost-iostreams-dev,
 libboost-python-dev,
 libgsl0-dev,
 libmuparser-dev (>= 2.1.0),
 libqscintilla2-dev,
 libqt4-opengl-dev,
 libtachyon-dev,
 python-dev,
 qt4-dev-tools,
 xsltproc
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/ovito.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/ovito.git
Homepage: http://www.ovito.org/

Package: ovito
Architecture: any
Depends:
 python,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 ovito-doc,
 ovito-examples
Suggests:
 povray
Description: visualization and analysis tool for atomistic simulation data
 OVITO is a visualization and analysis software for atomistic
 simulation data. Being a single integrated application it covers both
 the analysis and the visualization of large-scale atomistic datasets
 produced by molecular dynamics/statics and Monte-Carlo simulation
 codes. Its name is an acronym for Open Visualization Tool,
 emphasizing that the software has been designed with flexibility and
 extensibility in mind.

Package: ovito-doc
Architecture: all
Depends:
 ${misc:Depends}
Suggests:
 ovito,
 ovito-examples
Section: doc
Description: documentation for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the User Manual for ovito.

Package: ovito-examples
Architecture: all
Depends:
 ${misc:Depends}
Recommends:
 ovito,
 ovito-doc
Section: doc
Description: tutorial examples for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the tutorial examples for ovito.
