=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DOVITO_BUILD_DOCUMENTATION=TRUE \
	-DOVITO_BUILD_PLUGIN_ATOMVIZ=TRUE \
	-DOVITO_BUILD_PLUGIN_CRYSTALANALYSIS=TRUE \
	-DOVITO_BUILD_PLUGIN_POVRAY=TRUE \
	-DOVITO_BUILD_PLUGIN_SCRIPTING=TRUE \
	-DOVITO_BUILD_PLUGIN_STDOBJECTS=TRUE

override_dh_install:
	dh_install --list-missing
	find ./debian/ovito -type d -empty -delete
